= How do I add JDepend analysis to my project? =
[[TOC(heading=How do I...?,depth=1,HowTo/*)]]

[http://clarkware.com/software/JDepend.html JDepend] analyzes Java class files to generates design quality metrics for 
each Java package, in terms of its extensibility, reusability, and maintainability.

== For Maven projects ==

To use JDepend in a Maven project, add the following lines to your `pom.xml` file:

{{{
#!text/xml
<project>
  ...
  <reporting>
    <plugins>
      <plugin>
        <groupId>org.codehaus.mojo</groupId>
        <artifactId>jdepend-maven-plugin</artifactId>
      </plugin>
    </plugins>
  </reporting>
  ...
</project>
}}}

JDepend will report its findings as part of the Maven site report (`mvn site`).

== For Ant builds ==

To use JDepend in an Ant project, add the following files to your Ant directory (`$ANT_HOME`):
 * `lib/`
  * `jdepend-<%= node['tools']['jdepend']['version'] %>.jar`
 * `etc/`
  * `jdepend.xsl`

Add the following lines to your `build.xml` file. `build.dir`, `compile.classpath`, 
and `classes.dir` should be set appropriately. 

{{{
#!text/xml
  <property name="jdepend.xsl.file" location ="${ant.home}/etc/jdepend.xsl"/>

  <property name="report.dir" location="${build.dir}/reports"/>
  <property name="jdepend.report.dir" location="${report.dir}/jdepend"/>

  <target name="jdepend" depends="compile" description="Analyze design quality metrics with JDepend">
    <property name="jdepend.report.xml" location="${jdepend.report.dir}/jdepend.xml"/>
    <mkdir dir="${jdepend.report.dir}"/>
    <jdepend format="xml" outputfile="${jdepend.report.xml}">
      <exclude name="java.*"/>
      <exclude name="javax.*"/>
      <classespath>
        <pathelement location="${classes.dir}"/>
      </classespath>
      <classpath location="${compile.classpath}"/>
    </jdepend>

    <property name="jdepend.report.html" location="${jdepend.report.dir}/index.html"/>
    <xslt in="${jdepend.report.xml}" style="${jdepend.xsl.file}" out="${jdepend.report.html}"/>
    <echo message="JDepend report is at ${jdepend.report.html}"/>
  </target>
}}}

=== More information ===

 * [http://mojo.codehaus.org/jdepend-maven-plugin/ Maven plugin]
 * [http://clarkware.com/software/JDepend.html#ant Ant task]
 
<%= node['trac']['wiki']['footer'] %>